commit c5007722d5f5e86953912ea75b13575577e4f98a
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Dec 4 22:22:17 2025 +0000

    Perl: tweak dns lookup fail cases

diff --git a/src/src/dns.c b/src/src/dns.c
index dd754f6c9..5ed896b38 100644
--- a/src/src/dns.c
+++ b/src/src/dns.c
@@ -717,7 +717,7 @@ the packet length if the packet header looks plausible.
 
 Return TRUE iff it seemed ok */
 
-static BOOL
+BOOL
 fake_dnsa_len_for_fail(dns_answer * dnsa, int type)
 {
 const HEADER * h = (const HEADER *)dnsa->answer;
diff --git a/src/src/functions.h b/src/src/functions.h
index a15369af9..49ed1064d 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -248,6 +248,7 @@ extern uschar *expand_string_copy(const uschar *);
 extern int_eximarith_t expand_string_integer(uschar *, BOOL);
 extern void    modify_variable(uschar *, void *);
 
+extern BOOL    fake_dnsa_len_for_fail(dns_answer *, int);
 extern BOOL    fd_ready(int, time_t);
 extern BOOL    filter_runtest(int, const uschar *, BOOL, BOOL);
 
diff --git a/src/src/lookups/Makefile b/src/src/lookups/Makefile
index 23347e83b..27ae3fe1e 100644
--- a/src/src/lookups/Makefile
+++ b/src/src/lookups/Makefile
@@ -40,7 +40,7 @@ avail_static_lookups.o: $(HDRS) avail_static_lookups.c
 lookups.a:       avail_static_lookups.o $(OBJS)
 		 @$(RM_COMMAND) -f lookups.a
 		 @echo "$(AR) lookups.a"
-		 @$(AR) lookups.a avail_static_lookups.o $(OBJS)
+		 $(FE)$(AR) lookups.a avail_static_lookups.o $(OBJS)
 		 $(RANLIB) $@
 
 .SUFFIXES:       .o .c .so
diff --git a/src/src/miscmods/perl.c b/src/src/miscmods/perl.c
index cee920c77..5877d3dea 100644
--- a/src/src/miscmods/perl.c
+++ b/src/src/miscmods/perl.c
@@ -158,6 +158,8 @@ debug_printf_indent(" dnsa answer %p len %d\n", dnsa->answer, dnsa->answerlen);
 ST(0) = sv_newmortal();
 if (dns_res == DNS_AGAIN || dns_res == DNS_FAIL)
   sv_setsv(ST(0), &PL_sv_undef);
+else if (dnsa->answerlen == -1 && !fake_dnsa_len_for_fail(dnsa, rrtype_int))
+  sv_setsv(ST(0), &PL_sv_undef);
 else
   sv_setpvn(ST(0), CCS dnsa->answer, (STRLEN) dnsa->answerlen);
 XSRETURN(1);	/* ? needed because there are 2 arg, but 1 res? */

